NFSTEST_INTEROP(1)

NAME
nfstest_interop - NFS interoperability tests

SYNOPSIS
nfstest_interop --server <server> [options]

DESCRIPTION
Basic interoperability tests verify that a file written with different versions of NFS is written correctly. The contents of the file are verified by reading the file back using one of the NFS versions.

The tests append different data from different versions of NFS one at a time then reads the contents of the file to verify it was written correctly. This is done twice for each test:

   1) Mount different versions of NFS (NFSv3, NFSv4, NFSv4.1)
   2) Create empty file
   3) Append data using NFSv3
   4) Append data using NFSv4
   5) Append data using NFSv4.1
   6) Read file and verify contents are correct
   7) Append data using NFSv3
   8) Append data using NFSv4
   9) Append data using NFSv4.1
  10) Read file and verify contents are correct

OPTIONS

--version
    show program's version number and exit

-h, --help
    show this help message and exit

-f FILE, --file=FILE
    File where options are specified besides the system wide file /etc/nfstest, user wide file $HOME/.nfstest or in the current directory .nfstest file

  NFS specific options:

-s SERVER, --server=SERVER
    Server name or IP address

-e EXPORT, --export=EXPORT
    Exported file system to mount [default: '/']

--nfsversion=NFSVERSION
    NFS version, e.g., 3, 4, 4.1, etc. [default: 4.1]

-m MTPOINT, --mtpoint=MTPOINT
    Mount point [default: '/mnt/t']

-p PORT, --port=PORT
    NFS server port [default: 2049]

--proto=PROTO
    NFS protocol name [default: 'tcp']

--sec=SEC
    Security flavor [default: 'sys']

--nconnect=NCONNECT
    Multiple TCP connections option [default: '1']

-o MTOPTS, --mtopts=MTOPTS
    Mount options [default: 'hard,rsize=4096,wsize=4096']

--datadir=DATADIR
    Data directory where files are created, directory is created on the mount point [default: '']

  Logging options:

-v VERBOSE, --verbose=VERBOSE
    Verbose level for debug messages [default: 'opts|info|dbg1|dbg2|dbg3']

--tverbose=TVERBOSE
    Verbose level for test messages [default: '1']

--createlog
    Create log file

--rexeclog
    Create rexec log files

--warnings
    Display warnings

--tag=TAG
    Informational tag, it is displayed as an INFO message [default: '']

--notty
    Do not use terminal colors on output

--isatty
    Use terminal colors on output -- useful when running with nohup

  Packet trace options:

--createtraces
    Create a packet trace for each test

--tbsize=TBSIZE
    Capture buffer size for tcpdump [default: 192k]

--trcdelay=TRCDELAY
    Seconds to delay before stopping packet trace [default: 2.0]

--keeptraces
    Do not remove any trace files [default: remove trace files if no errors]

--rmtraces
    Remove trace files [default: remove trace files if no errors]

-i INTERFACE, --interface=INTERFACE
    Device interface [default: automatically selected]

  File options:

--nfiles=NFILES
    Number of files to create [default: 2]

--filesize=FILESIZE
    File size to use for test files [default: 64k]

--rsize=RSIZE
    Read size to use when reading files [default: 4k]

--wsize=WSIZE
    Write size to use when writing files [default: 4k]

--iodelay=IODELAY
    Seconds to delay I/O operations [default: 0.1]

--offset-delta=OFFSET_DELTA
    Read/Write offset delta [default: 4k]

  Path options:

--sudo=SUDO
    Full path of binary for sudo [default: '/usr/bin/sudo']

--kill=KILL
    Full path of binary for kill [default: '/usr/bin/kill']

--nfsstat=NFSSTAT
    Full path of binary for nfsstat [default: '/usr/sbin/nfsstat']

--tcpdump=TCPDUMP
    Full path of binary for tcpdump [default: '/usr/sbin/tcpdump']

--iptables=IPTABLES
    Full path of binary for iptables [default: '/usr/sbin/iptables']

--messages=MESSAGES
    Full path of log messages file [default: '/var/log/messages']

--trcevents=TRCEVENTS
    Full path of tracing events directory [default: '/sys/kernel/debug/tracing/events']

--trcpipe=TRCPIPE
    Full path of trace pipe file [default: '/sys/kernel/debug/tracing/trace_pipe']

--tmpdir=TMPDIR
    Temporary directory [default: '/tmp']

  Debug options:

--nocleanup
    Do not cleanup created files

--notimestamps
    Do not display timestamps in debug messages

--bugmsgs=BUGMSGS
    File containing test messages to mark as bugs if they failed

--nomount
    Do not mount server and run the tests on local disk space

--basename=BASENAME
    Base name for all files and logs [default: automatically generated]

--nfsdebug=NFSDEBUG
    Set NFS kernel debug flags and save log messages [default: '']

--rpcdebug=RPCDEBUG
    Set RPC kernel debug flags and save log messages [default: '']

--tracepoints=TRACEPOINTS
    List of trace points modules to enable [default: '']

--nfsstats
    Get NFS stats [default: 'False']

--pktdisp
    Display main packets related to the given test

--nfserrors
    Fail every NFS error found in the packet trace

--client-ipaddr=CLIENT_IPADDR
    IP address of localhost

  Reporting options:

--xunit-report
    Generate xUnit compatible test report

--xunit-report-file=XUNIT_REPORT_FILE
    Path to xout report file

  Test options:

--runtest=RUNTEST
    Comma separated list of tests to run, if list starts with a '^' then all tests are run except the ones listed [default: 'all']

--datasize=DATASIZE
    Size of data to be written by each version of NFS [default: '10']

TESTS

  test01
Verify appending data with NFSv3 is correctly read using NFSv3

  test02
Verify appending data with NFSv3 is correctly read using NFSv4

  test03
Verify appending data with NFSv3 is correctly read using NFSv4.1

  test04
Verify appending data with NFSv4 is correctly read using NFSv3

  test05
Verify appending data with NFSv4 is correctly read using NFSv4

  test06
Verify appending data with NFSv4 is correctly read using NFSv4.1

  test07
Verify appending data with NFSv4.1 is correctly read using NFSv3

  test08
Verify appending data with NFSv4.1 is correctly read using NFSv4

  test09
Verify appending data with NFSv4.1 is correctly read using NFSv4.1

  test10
Verify appending data with NFSv3 and NFSv4 is correctly read using NFSv3

  test11
Verify appending data with NFSv3 and NFSv4 is correctly read using NFSv4

  test12
Verify appending data with NFSv3 and NFSv4 is correctly read using NFSv4.1

  test13
Verify appending data with NFSv4 and NFSv3 is correctly read using NFSv3

  test14
Verify appending data with NFSv4 and NFSv3 is correctly read using NFSv4

  test15
Verify appending data with NFSv4 and NFSv3 is correctly read using NFSv4.1

  test16
Verify appending data with NFSv3 and NFSv4.1 is correctly read using NFSv3

  test17
Verify appending data with NFSv3 and NFSv4.1 is correctly read using NFSv4

  test18
Verify appending data with NFSv3 and NFSv4.1 is correctly read using NFSv4.1

  test19
Verify appending data with NFSv4.1 and NFSv3 is correctly read using NFSv3

  test20
Verify appending data with NFSv4.1 and NFSv3 is correctly read using NFSv4

  test21
Verify appending data with NFSv4.1 and NFSv3 is correctly read using NFSv4.1

  test22
Verify appending data with NFSv4 and NFSv4.1 is correctly read using NFSv3

  test23
Verify appending data with NFSv4 and NFSv4.1 is correctly read using NFSv4

  test24
Verify appending data with NFSv4 and NFSv4.1 is correctly read using NFSv4.1

  test25
Verify appending data with NFSv4.1 and NFSv4 is correctly read using NFSv3

  test26
Verify appending data with NFSv4.1 and NFSv4 is correctly read using NFSv4

  test27
Verify appending data with NFSv4.1 and NFSv4 is correctly read using NFSv4.1

  test28
Verify appending data with NFSv3, NFSv4 and NFSv4.1 is correctly read using NFSv3

  test29
Verify appending data with NFSv3, NFSv4 and NFSv4.1 is correctly read using NFSv4

  test30
Verify appending data with NFSv3, NFSv4 and NFSv4.1 is correctly read using NFSv4.1

  test31
Verify appending data with NFSv4, NFSv3 and NFSv4.1 is correctly read using NFSv3

  test32
Verify appending data with NFSv4, NFSv3 and NFSv4.1 is correctly read using NFSv4

  test33
Verify appending data with NFSv4, NFSv3 and NFSv4.1 is correctly read using NFSv4.1

  test34
Verify appending data with NFSv4, NFSv4.1 and NFSv3 is correctly read using NFSv3

  test35
Verify appending data with NFSv4, NFSv4.1 and NFSv3 is correctly read using NFSv4

  test36
Verify appending data with NFSv4, NFSv4.1 and NFSv3 is correctly read using NFSv4.1

  test37
Verify appending data with NFSv4.1, NFSv4 and NFSv3 is correctly read using NFSv3

  test38
Verify appending data with NFSv4.1, NFSv4 and NFSv3 is correctly read using NFSv4

  test39
Verify appending data with NFSv4.1, NFSv4 and NFSv3 is correctly read using NFSv4.1

  test40
Verify appending data with NFSv4.1, NFSv3 and NFSv4 is correctly read using NFSv3

  test41
Verify appending data with NFSv4.1, NFSv3 and NFSv4 is correctly read using NFSv4

  test42
Verify appending data with NFSv4.1, NFSv3 and NFSv4 is correctly read using NFSv4.1

  test43
Verify appending data with NFSv3, NFSv4.1 and NFSv4 is correctly read using NFSv3

  test44
Verify appending data with NFSv3, NFSv4.1 and NFSv4 is correctly read using NFSv4

  test45
Verify appending data with NFSv3, NFSv4.1 and NFSv4 is correctly read using NFSv4.1

  all
Run all tests: test01, test02, test03, test04, test05, test06, test07,
test08, test09, test10, test11, test12, test13, test14, test15, test16,
test17, test18, test19, test20, test21, test22, test23, test24, test25,
test26, test27, test28, test29, test30, test31, test32, test33, test34,
test35, test36, test37, test38, test39, test40, test41, test42, test43,
test44, test45

SEE ALSO
nfstest.test_util(3), nfstest_alloc(1), nfstest_cache(1), nfstest_delegation(1), nfstest_dio(1), nfstest_fcmp(1), nfstest_file(1), nfstest_io(1), nfstest_lock(1), nfstest_pkt(1), nfstest_pnfs(1), nfstest_posix(1), nfstest_rdma(1), nfstest_sparse(1), nfstest_ssc(1), nfstest_xattr(1), nfstest_xid(1), packet.nfs.nfs3_const(3), packet.nfs.nfs4_const(3)

BUGS
No known bugs.

AUTHOR
Jorge Mora (mora@netapp.com)